<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelTaxaDeServicoPorVendaService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function find($CDFILIAL, $TCDFILIAL, $CDLOJA, $TCDLOJA, $DTABERCAIX, $TDTABERCAIX, $DATAINI, $DATAFIN, $CDVENDEDOR, $TCVENDEDOR) {
        $params = array(
                            ':CDFILIAL'         => $CDFILIAL,
                            ':TCDFILIAL'        => $TCDFILIAL,
                            ':CDLOJA'           => $CDLOJA,
                            ':TCDLOJA'          => $TCDLOJA,
                            ':DTMOVTURCAIX'     => $DTABERCAIX,
                            ':TDTMOVTURCAIX'    => $TDTABERCAIX,
                            ':DATAINI'          => $DATAINI,
                            ':DATAFIN'          => $DATAFIN,
                            ':CDVENDEDOR'       => $CDVENDEDOR,
                            ':TCDVENDEDOR'      => $TCVENDEDOR
                        );

 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDAS, $params);;
    }
    
    const GET_VENDAS = "
        SELECT F.CDFILIAL, 
               F.NMFILIAL, 
               L.CDLOJA, 
               L.NMLOJA,
               V.CDCAIXA, 
               V.NRNOTAFISCALCE, 
               V.NRSEQVENDA,
               V.DTVENDA, 
               V.VRTXSEVENDA VRTAXA,
               V.CDVENDEDOR || ' - ' || VV.NMRAZSOCVEN AS GARCON,
               F.CDFILIAL || ' - ' || F.NMFILIAL AS LABELFILIAL,
               SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0)) AS VRVENDA,
               SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) + NVL(I.VRACRITVEND,0) - NVL(I.VRDESITVEND,0)) AS VRTOTVENDA 
          FROM VENDA V, ITEMVENDA I, FILIAL F, LOJA L, VENDEDOR VV
         WHERE V.CDFILIAL    = F.CDFILIAL
           AND V.CDFILIAL    = L.CDFILIAL
           AND V.CDLOJA      = L.CDLOJA
           AND V.CDFILIAL    = I.CDFILIAL
           AND V.CDCAIXA     = I.CDCAIXA
           AND V.NRSEQVENDA  = I.NRSEQVENDA
           AND V.CDVENDEDOR  = VV.CDVENDEDOR
           AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
           AND V.IDSITUVENDA = 'O'
           AND V.NRACESSONFCE IS NOT NULL
           AND ((INSTR(:DTMOVTURCAIX, V.CDFILIAL||V.CDCAIXA||TO_CHAR(V.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS')) > 0) OR (:TDTMOVTURCAIX = 'T'))
           AND ((INSTR(:CDLOJA      , V.CDFILIAL||V.CDLOJA) <> 0) OR (:TCDLOJA   = 'T')) 
           AND ((INSTR(:CDFILIAL    , V.CDFILIAL          ) <> 0) OR (:TCDFILIAL = 'T'))
           AND ((INSTR(:CDVENDEDOR, V.CDVENDEDOR) > 0) OR (:TCDVENDEDOR = 'T'))
        GROUP BY V.NRSEQVENDA, V.NRNOTAFISCALCE, F.CDFILIAL, F.NMFILIAL, L.CDLOJA, 
            L.NMLOJA, V.DTVENDA, V.CDCAIXA, V.VRTXSEVENDA, V.CDVENDEDOR, 
            V.CDVENDEDOR || ' - ' || VV.NMRAZSOCVEN, VV.NMRAZSOCVEN
        ORDER BY V.NRNOTAFISCALCE

    ";
}